<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>investment-oficial documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">investment-oficial documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>FlujoNeto</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/core/result/proyect-result/proyect-result.component.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                        <a href="#anio">anio</a>
                                </li>
                                <li>
                                        <a href="#flujo">flujo</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="anio"></a>
                                        <span class="name"><b>anio</b><a href="#anio"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>anio:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="flujo"></a>
                                        <span class="name"><b>flujo</b><a href="#flujo"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>flujo:         <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild } from &#x27;@angular/core&#x27;;
import { DataProyectService } from &#x27;src/app/service/data-proyect.service&#x27;;
import { ChartDataSets, ChartOptions, ChartType } from &#x27;chart.js&#x27;;
import { Color, BaseChartDirective, Label } from &#x27;ng2-charts&#x27;;
import { PdfMakeWrapper, Img, Table } from &#x27;pdfmake-wrapper&#x27;;
import { ITable } from &#x27;pdfmake-wrapper/lib/interfaces&#x27;;
import * as html2pdf from &#x27;html2pdf.js&#x27;;
import { Router } from &#x27;@angular/router&#x27;;

export interface FlujoNeto {
  flujo: number;
  anio: number;
}
export interface SecondResult {
  index: number;
  inv_ini: number;
  anio_1: number;
  anio_2: number;
  anio_3: number;
  anio_4: number;
  anio_5: number;
  VPN: number;
  inflacion: number;
}
export interface SecondData {
  id: number;
  id_proyc: number;
  tipo: string;
  est_pes: number;
  est_prob: number;
  est_opt: number;
  yeear: number;
}
export interface DisplaySecondResult {
  name: string;
}
@Component({
  selector: &#x27;app-proyect-result&#x27;,
  templateUrl: &#x27;./proyect-result.component.html&#x27;,
  styleUrls: [&#x27;./proyect-result.component.css&#x27;]
})
export class ProyectResultComponent implements OnInit {

  public lineChartData: ChartDataSets[] &#x3D; [];
  public lineChartSecondData: ChartDataSets[] &#x3D; [];
  public lineChartLabels: Label[] &#x3D; [];
  public lineChartOptions: (ChartOptions &amp; { annotation: any }) &#x3D; {
    responsive: true,
    scales: {
      // We use this empty structure as a placeholder for dynamic theming.
      xAxes: [{}],
      yAxes: [
        {
          id: &#x27;y-axis-0&#x27;,
          position: &#x27;left&#x27;,
        },
        {
          id: &#x27;y-axis-1&#x27;,
          position: &#x27;right&#x27;,
          gridLines: {
            color: &#x27;rgba(255,0,0,0.3)&#x27;,
          },
          ticks: {
            fontColor: &#x27;red&#x27;,
          }
        }
      ]
    },
    annotation: {
      annotations: [
        {
          type: &#x27;line&#x27;,
          mode: &#x27;vertical&#x27;,
          scaleID: &#x27;x-axis-0&#x27;,
          value: &#x27;March&#x27;,
          borderColor: &#x27;orange&#x27;,
          borderWidth: 2,
          label: {
            enabled: true,
            fontColor: &#x27;orange&#x27;,
            content: &#x27;LineAnno&#x27;
          }
        },
      ],
    },
  };
  public lineChartColors: Color[] &#x3D; [
    { // grey
      backgroundColor: &#x27;rgba(148,159,177,1)&#x27;,
      borderColor: &#x27;rgba(148,159,177,1)&#x27;,
      pointBackgroundColor: &#x27;rgba(148,159,177,1)&#x27;,
      pointBorderColor: &#x27;#fff&#x27;,
      pointHoverBackgroundColor: &#x27;#fff&#x27;,
      pointHoverBorderColor: &#x27;rgba(148,159,177,0.8)&#x27;
    },
    { // dark grey
      backgroundColor: &#x27;rgba(77,83,96,0.2)&#x27;,
      borderColor: &#x27;rgba(77,83,96,1)&#x27;,
      pointBackgroundColor: &#x27;rgba(77,83,96,1)&#x27;,
      pointBorderColor: &#x27;#fff&#x27;,
      pointHoverBackgroundColor: &#x27;#fff&#x27;,
      pointHoverBorderColor: &#x27;rgba(77,83,96,1)&#x27;
    },
    { // red
      backgroundColor: &#x27;rgba(255,0,0,0.3)&#x27;,
      borderColor: &#x27;red&#x27;,
      pointBackgroundColor: &#x27;rgba(148,159,177,1)&#x27;,
      pointBorderColor: &#x27;#fff&#x27;,
      pointHoverBackgroundColor: &#x27;#fff&#x27;,
      pointHoverBorderColor: &#x27;rgba(148,159,177,0.8)&#x27;
    }
  ];
  public lineChartLegend &#x3D; true;
  public lineChartType: ChartType &#x3D; &#x27;line&#x27;;
  public barChartType: ChartType &#x3D; &#x27;bar&#x27;;

  @ViewChild(BaseChartDirective, { static: true }) chart: BaseChartDirective;

  tir: number;
  aprove: boolean;
  denied: boolean;
  nameProyect: any;
  year: number;

  displayedColumns &#x3D; [&#x27;anio&#x27;, &#x27;flujo&#x27;];
  displayedSecondColumns &#x3D; [&#x27;tipo&#x27;, &#x27;est_pes&#x27;, &#x27;est_prob&#x27;, &#x27;est_opt&#x27;];
  displayedSecondColumnsResult: DisplaySecondResult[] &#x3D; [];
  displayedSecondColumnsResultAux &#x3D; [];

  flujoNeto: FlujoNeto[];
  secondData: SecondData[];
  secondResultData: SecondResult[];
  vpn &#x3D; [];

  inversion: any;
  firstOption &#x3D; false;
  secondOption &#x3D; false;
  prom: number;
  constructor(private dataProyectService: DataProyectService,
              private router: Router) { }

  ngOnInit(): void {
    this.verifyEscenary();
  }
  verifyEscenary(): any {
    const idResult &#x3D; localStorage.getItem(&#x27;id_dataFirst&#x27;);
    const idProyect &#x3D; localStorage.getItem(&#x27;id_proy&#x27;);
    const option &#x3D; localStorage.getItem(&#x27;option&#x27;);
    // tslint:disable-next-line: triple-equals
    this.dataProyectService.getNameProyect(idProyect).subscribe(
      res &#x3D;&gt; {
        this.nameProyect &#x3D; res.name;
        // console.log(res);
      }, error &#x3D;&gt; {
        console.log(error);
      }
      );
    // tslint:disable-next-line: triple-equals
    if (option &#x3D;&#x3D; &#x27;first&#x27;) {
      this.firstOption &#x3D; true;
      this.dataProyectService.getFirstResult(idResult).subscribe(
        res &#x3D;&gt; {
          this.buildTableFlujo(res.fjNeto, res.year);
          this.inversion &#x3D; res.invertion;
          this.tir &#x3D; res.tir * 100;
          if (this.tir &gt; 30) {
            this.aprove &#x3D; true;
          }else {
            this.denied &#x3D; true;
          }
          console.log(res);
          console.log(this.tir);
        }, error &#x3D;&gt; {
          console.log(error);
        }
      );
      this.dataProyectService.getFirstData(idResult).subscribe(
        res &#x3D;&gt; {
          this.year &#x3D; res.year;
          console.log(res);
        }, error &#x3D;&gt; {
          console.log(error);
        }
      );
    }else {
      this.secondOption &#x3D; true; 
      this.dataProyectService.getSecondData(idProyect).subscribe(
        res &#x3D;&gt; {
          this.secondData &#x3D; res;
          // this.buildTableSecondData(res);
        }, error &#x3D;&gt; {
          console.log(error);
        }
      );
      this.dataProyectService.getSecondResult(idProyect).subscribe(
        res &#x3D;&gt; {
          this.displayedSecondColumnsResult &#x3D; res.schema.fields;
          this.secondResultData &#x3D; res.data;
          // console.log(res.data);
          this.buildLineSecondChart(res.data);
          this.buildSecondColumns(res.schema.fields);
        }, error &#x3D;&gt; {
          console.log(error);
        }
      );
    }
  }
  buildLineSecondChart(datas: any) {
    let arrayAux &#x3D; [];
    for (const data of  datas) {
      // console.log(data.VPN);
      arrayAux.push(data.VPN);
    }
    this.vpn &#x3D; arrayAux;
    const suma &#x3D; this.vpn.reduce((previous, current) &#x3D;&gt; current +&#x3D; previous);
    this.prom &#x3D; suma / this.vpn.length;
    if (this.prom &gt; 0) {
      this.aprove &#x3D; true;
    }else {
      this.denied &#x3D; true;
    }
    console.log(&quot;Premdio  VPN:&quot; + this.prom);
    const newLineChartData &#x3D; {
      data: this.vpn,
      label: &#x27;VPN&#x27;
    };
    this.lineChartData.push(newLineChartData);
    console.log(this.lineChartData);
    console.log(this.vpn);
    for (let i &#x3D; 0; i &lt;&#x3D; 100; i++) {
      const j &#x3D; i + 1;
      this.lineChartLabels.push(&quot;i:&quot; + j);
    }
  }
  buildSecondColumns(fields: any) {
    let arrayAux &#x3D; []
    for(const field of fields){
      const name: string &#x3D; field.name;
      arrayAux.push(name);
    }
    this.displayedSecondColumnsResultAux &#x3D; arrayAux;
    arrayAux &#x3D;  [];
    // console.log(this.displayedSecondColumnsResultAux);
  }
  buildTableSecondData(secondData: any) {
    // console.log(secondData);
    // tslint:disable-next-line: prefer-for-of
    for (let i &#x3D; 0; i &lt; secondData.length; i++) {
      const data &#x3D; secondData[i];
      this.secondData.push(data);
    }
    console.log(this.secondData);
  }
  buildTableFlujo(fjNeto, year: number): any {
    const arrayAux &#x3D; [];
    const arraAuxSecond &#x3D; [];
    for (let i &#x3D; 0; i &lt; fjNeto.length; i++) {
      const flujo &#x3D; {
        anio: i + 1,
        flujo: fjNeto[i]
      };
      const label &#x3D; &#x27;Año &#x27; + i + 1;
      arraAuxSecond.push(label);
      arrayAux.push(flujo);
      const j &#x3D; i + 1;
      this.lineChartLabels.push(&#x27;Año &#x27; + j);
    }
    this.flujoNeto &#x3D; arrayAux;
    console.log(this.flujoNeto);
    const newLineChartData &#x3D; {
      data: fjNeto,
      label: &#x27;Flujo neto&#x27;
    };
    this.lineChartData.push(newLineChartData);
    console.log(this.lineChartLabels);
  }
  async generatePdf() {
    const option &#x3D; localStorage.getItem(&quot;option&quot;);
    if (option &#x3D;&#x3D; &#x27;first&#x27;) {
      var element &#x3D; document.getElementById(&#x27;element-to-print&#x27;);
      html2pdf(element);
    }else{
      var element2 &#x3D; document.getElementById(&#x27;second-element-to-print&#x27;);
      html2pdf(element2);
    }
    // const pdf &#x3D; new PdfMakeWrapper();
    // pdf.add(&#x27;INVESTMENT SOFT&#x27;);
    // // pdf.add( await new Img(&#x27;&#x27;).build());
    // pdf.add(&#x27;---------------------------------------&#x27;);
    // pdf.add(&#x27;Nombre de Proyecto: &#x27; + this.nameProyect);
    // pdf.add(&#x27;---------------------------------------&#x27;);
    // pdf.add(&#x27;Tasa Interna de Retorno: &#x27; + this.tir + &#x27; %&#x27;);
    // pdf.add(&#x27;---------------------------------------&#x27;);
    // pdf.add(&#x27;Inversión del Proyecto:  &#x27; + this.inversion + &#x27; $&#x27;);
    // pdf.add(&#x27;---------------------------------------&#x27;);
    // pdf.add(&#x27;Flujo neto en el periodo t &#x3D;  &#x27; + this.year + &#x27; años&#x27;);
    // pdf.add(&#x27;---------------------------------------&#x27;);
    // pdf.add(this.createTablePdf(this.flujoNeto)); 
    // pdf.create().open();
  }
  createTablePdf(data: FlujoNeto[]): ITable {
    [{ }]
    return new Table([
      [&#x27;Año&#x27;, &#x27;Flujo Neto&#x27;],
      ...this.extractDataTable(data)
    ]).end;
  }
  extractDataTable(data: FlujoNeto[]){
    return data.map(row &#x3D;&gt; [row.anio, row.flujo]);
  }
  goToHome(){
    this.router.navigateByUrl(&#x27;core/result/proyect-result&#x27;, { skipLocationChange: true }).then(() &#x3D;&gt; {
      this.router.navigate([&#x27;core/home&#x27;]);
    });
  }
}
</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'FlujoNeto.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
